/*---------------------------------------------------------------------------------------------------------------------------------------------------------------------
NOTE: [ I STAND ON THE SHOULDERS OF GIANTS ]

		SNS_SHI_FIBS_CHANNEL is modified from SHI_CHANNEL_TRUE_TRO_MODIFIED_VERSION by Avery T. Horton, aka TheRumpledOne, which was itself a modified version 
		of the original SHI_CHANNEL_TRUE origianlly created by Shurka & Kevin.  I adhere to the MOTTO OF TRUE PROGRAMMERS:  ** ADAPT - MODIFY - IMPROVE **
		I rarely claim any program I develop is "100% uniquely my code".  More of my and TRO's indicators can be found at www.kreslik.com.


-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
SNS_SHI_FIBS_CHANNEL by Steven N. Scott (aka SNSCOTT):

Copyright (C) 2009, Steven N. Scott
mailto:steven.n.scott@gmail.com
_____________________________________________________________________________________________________________
Version History

v1.0			Initial Release																							11/12/2009
v1.1			Added CHANNEL.RAY option to make lines extend													11/12/2009
v1.1a			Fixed CHANNEL.RAY bug with FIBO lines (could not turn them off "extend" mode)			11/12/2009
v1.2			Modified to use SNS_ObjectLibrary.mqh																11/30/2009

_____________________________________________________________________________________________________________


Modification of the SHI_CHANNEL_TRUE code to add FIB CHANNELS to the SHI CHANNEL and to allow for (optionally) displaying SHI Channels from multiple timeframes 
on one chart in addition to providing a simple,optional gauge with SHI Channel data in numerical form.  

Up/Down/Sideways colors are independently adjustable by the user for each time frame.

--------------------------------------------------------------------------------------------------------------------------------------------------------------------- */

#property copyright "(c) - 2004-Shurka & Kevin / 2009-Avery T. Horton / 2009-Steven N. Scott"
#property link "steven.n.scott@gmail.com"

// THE FOLLWING INCLUDE (MQH) FILE NEEDS TO BE IN THE EXPERTS\INCLUDES FOLDER
#include <SNS_ObjectLibrary.mqh>

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Pink


//____________________________________________________________________________________________________________________________________________________________
// INDICATOR CUSTOMIZABLE PROPERTIES

extern string			ChartSymbol					= "";
extern int				ChartPeriod					= 0;
extern bool   			SoundAlert   	 				= false;

extern string			gaugenote						= "GAUGE OPTIONS--------------------";
extern bool				GaugeShow						= false;
extern int				GaugeCorner					= 1;
extern int				GaugeX							= 120;
extern int				GaugeY							= 10;
extern int				GaugeLineSpacing 			= 25;
extern int				HeaderX							= -100;
extern int				HeaderY							= 0;
extern int				Col1X							= 0;
extern int				Col2X							= -90;
extern string			HeaderFont						= "Verdana BOLD";
extern int				HeaderFontSize				= 14;
extern color			HeaderFontColor  			= RoyalBlue;
extern string			LabelFont						= "Verdana";
extern int				LabelFontSize					= 12;
extern color			LabelFontColor  				= Goldenrod;
extern string			ValueFont						= "Verdana";
extern int				ValueFontSize					= 12;
extern color			ValueFontColor  				= LightGray;

extern string			shinote							= "SHI CHANNEL OPTIONS---------------";
extern int 				BarsForFract 					= 0;
extern int				ChannelLineWidth			= 8;
extern int				ChannelLineStyle			= 0;
extern int				ChannelMidLineWidth		= 1;
extern int				ChannelMidLineStyle		= 0;
extern bool				ChannelRay						= true;
extern color			ChannelColorUp				= Lime;
extern color			ChannelColorDn				= Red;
extern color			ChannelColorEq				= Yellow;

extern int				BreakoutArrow					= 174;
extern color			BreakoutColor					= LemonChiffon;
extern int				BreakoutSize					= 5;

extern bool   			PriceBoxShow  				= false;
extern int    			PriceBoxWidth    			= 3;
extern color			PriceBoxColor					= DimGray;
extern int 				AllBars 							= 240;

extern string			fibonote						= "FIBO CHANNEL OPTIONS-------------";
extern bool				FiboShow						= true;
extern int				FiboWidth						= 1;
extern int				FiboStyle						= 0;
extern color			FiboColor						= DimGray;
extern color			FiboLevelColor				= DimGray;
extern int				FiboLevelWidth				= 1;
extern int				FiboLevelStyle				= 2;


extern string			multiplenote					= "MULTIPLE TIMEFRAME OPTIONS-------";
extern bool				ChannelWeekShow 			= false;
extern bool				ChannelDayShow 				= false;
extern bool				ChannelH4Show 				= false;
extern bool				ChannelH1Show 				= false;

extern color			WeekColorUp					= DarkGreen;
extern color			WeekColorDn					= Maroon;
extern color			WeekColorEq					= DarkGoldenrod;

extern color			DayColorUp					= Green;
extern color			DayColorDn					= FireBrick;
extern color			DayColorEq					= DarkOrange;

extern color			H4ColorUp						= SeaGreen;
extern color			H4ColorDn						= Crimson;
extern color			H4ColorEq						= Orange;

extern color			H1ColorUp						= MediumSeaGreen;
extern color			H1ColorDn						= Coral;
extern color			H1ColorEq						= C'255,255,155';



//____________________________________________________________________________________________________________________________________________________________
// BUFFERS

double ExtMapBuffer1[],slopebuffer[];


//____________________________________________________________________________________________________________________________________________________________
//INTERNAL GLOBALS

int CurrentBar = 0, B1 = -1, B2 = -1,UpDown = 0,i = 0, AB = 300, BFF = 0, ishift = 0, OldBars = -1, digits, period;
double Step = 0,P1 = 0, P2 = 0, PP = 0,iprice = 0, point=10, pips=10;
 
datetime T1, T2, Trigger;

string symbol, tag, ChartName;  

color ChannelColor 	= White;

color WeekColor,DayColor,H4Color,H1Color;

double UpperLR, LowerLR, MiddleLR, Slope, ChannelSize; 
 

//***************************************************************************************************************************************************************
//STANDARD INDICATOR FUNCTIONS

int init() {

   if (ChartPeriod==0) period = Period(); else period=ChartPeriod;
   if (ChartSymbol=="") symbol = Symbol(); else symbol=ChartSymbol;
   ChartName	 =  ChartSymbol + ":"+Time_TFToString(period) ;

   digits       =  Digits ;   
   point        =  Point ;   
   if(Digits == 5 || Digits == 3) point = point * 10 ;
   
   
   DeleteObjectsByPrefix("shict:");
    
   tag = "shict:"+period+":";
      
   SetIndexArrow(0, BreakoutArrow);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexEmptyValue(0, 0.0);
   SetStyles();

   return(0);
   
}

int deinit() {
  
   DeleteObjectsByPrefix(tag);
   Comment(" ");

   return(0);
   
}


int start() {

	SetStyles();
	
	return(ShowDashboard());
   
}

//***************************************************************************************************************************************************************
//CUSTOM INDICATOR FUNCTIONS

//____________________________________________________________________________________________________________________________________________________________

void SetStyles(){

   SetIndexStyle(0, DRAW_ARROW, 0, BreakoutSize, BreakoutColor);

}


//____________________________________________________________________________________________________________________________________________________________
//DISPLAY DASHBOARD

int ShowDashboard(){

	double SlopeWeek = PeriodTrend(symbol,PERIOD_W1, AllBars);  	if (ChannelWeekShow && period!=PERIOD_W1) DrawChannel(PERIOD_W1,SlopeWeek);
	double SlopeDay	= PeriodTrend(symbol,PERIOD_D1 ,AllBars);		if (ChannelDayShow  && period!=PERIOD_D1) DrawChannel(PERIOD_D1,SlopeDay);
	double SlopeH4	= PeriodTrend(symbol,PERIOD_H4,AllBars);		if (ChannelH4Show   && period!=PERIOD_H4) DrawChannel(PERIOD_H4,SlopeH4);
	double SlopeH1	= PeriodTrend(symbol,PERIOD_H1,AllBars);		if (ChannelH1Show   && period!=PERIOD_H1) DrawChannel(PERIOD_H1,SlopeH1);

	if(SlopeWeek > 0) 	WeekColor 	= WeekColorUp; else if(SlopeWeek < 0) 	WeekColor 	= WeekColorDn;  else 	WeekColor 	= WeekColorEq; 
	if(SlopeDay > 0) 	DayColor 	= DayColorUp;  else if(SlopeDay < 0) 	DayColor 	= DayColorDn;   else  DayColor 	= DayColorEq; 
	if(SlopeH4 > 0) 		H4Color 	= H4ColorUp;   else if(SlopeH4 < 0) 	H4Color 	= H4ColorDn;  	else  H4Color 	= H4ColorEq; 
	if(SlopeH1 > 0) 		H1Color 	= H1ColorUp;   else if(SlopeH1 < 0) 	H1Color 	= H1ColorDn;  	else  H1Color 	= H1ColorEq; 

	Slope=PeriodTrend(symbol,period,AllBars); 
	slopebuffer[0]=Slope;
	DrawChannel(period,Slope);
	
   //DeleteObjectsByPrefix(tag);
   
   if( GaugeShow ) {
   
   	int row=GaugeY;
   	Draw_Label(tag, "header", symbol+" SHI CHANNEL", GaugeCorner, GaugeX+HeaderX, row+HeaderY, HeaderFont, HeaderFontSize, HeaderFontColor, false, 0);
   	row+=GaugeLineSpacing;
   	
   	Draw_Label(tag, "Channel", "CHANNEL", GaugeCorner, GaugeX+Col1X, row, LabelFont, LabelFontSize, LabelFontColor, false, 0);
   	Draw_Label(tag, "chnlsz",  DoubleToStr(ChannelSize/pips, 0)+" pips", GaugeCorner, GaugeX+Col2X, row, ValueFont, ValueFontSize, ValueFontColor, false, 0);
   
   	row+=GaugeLineSpacing;
   	Draw_Label(tag, "h1lope", "H1 SLOPE", GaugeCorner, GaugeX+Col1X, row, LabelFont, LabelFontSize, LabelFontColor, false, 0);
   	Draw_Label(tag, "c1slope",  DoubleToStr(SlopeH1, 0), GaugeCorner, GaugeX+Col2X, row, ValueFont, ValueFontSize, H1Color, false, 0);
   	
   	row+=GaugeLineSpacing;
   	Draw_Label(tag, "h4lope", "H4 SLOPE", GaugeCorner, GaugeX+Col1X, row, LabelFont, LabelFontSize, LabelFontColor, false, 0);
   	Draw_Label(tag, "c4slope",  DoubleToStr(SlopeH4, 0), GaugeCorner, GaugeX+Col2X, row, ValueFont, ValueFontSize, H4Color, false, 0);
   
   
   	row+=GaugeLineSpacing;
   	Draw_Label(tag, "DSlope", "D1 SLOPE", GaugeCorner, GaugeX+Col1X, row, LabelFont, LabelFontSize, LabelFontColor, false, 0);
   	Draw_Label(tag, "dslpe",  DoubleToStr(SlopeDay, 0), GaugeCorner, GaugeX+Col2X, row, ValueFont, ValueFontSize, DayColor, false, 0);

   	row+=GaugeLineSpacing;
   	Draw_Label(tag, "WSlope", "W1 SLOPE", GaugeCorner, GaugeX+Col1X, row, LabelFont, LabelFontSize, LabelFontColor, false, 0);
   	Draw_Label(tag, "wslpe",  DoubleToStr(SlopeWeek, 0), GaugeCorner, GaugeX+Col2X, row, ValueFont, ValueFontSize, WeekColor, false, 0);
      
   	row+=GaugeLineSpacing;
   	Draw_Label(tag, "lowr", "LOWER", GaugeCorner, GaugeX+Col1X, row, LabelFont, LabelFontSize, LabelFontColor, false, 0);
   	Draw_Label(tag, "lowrv",  DoubleToStr(LowerLR, digits), GaugeCorner, GaugeX+Col2X, row, ValueFont, ValueFontSize, ValueFontColor, false, 0);

   	row+=GaugeLineSpacing;
   	Draw_Label(tag, "uppr", "UPPER", GaugeCorner, GaugeX+Col1X, row, LabelFont, LabelFontSize, LabelFontColor, false, 0);
   	Draw_Label(tag, "upprv",  DoubleToStr(UpperLR, digits), GaugeCorner, GaugeX+Col2X, row, ValueFont, ValueFontSize, ValueFontColor, false, 0);

   	row+=GaugeLineSpacing;
   	Draw_Label(tag, "midr", "MIDDLE", GaugeCorner, GaugeX+Col1X, row, LabelFont, LabelFontSize, LabelFontColor, false, 0);
   	Draw_Label(tag, "midrv",  DoubleToStr(MiddleLR, digits), GaugeCorner, GaugeX+Col2X, row, ValueFont, ValueFontSize, ValueFontColor, false, 0);
  
      
   }        
           
   //if(iprice != 0) ExtMapBuffer1[ishift] = iprice;


   if ( Trigger != Time[0] &&  SoundAlert )   {
   
     if( Close[0] >= UpperLR ) { Trigger = Time[0] ; Alert(symbol,"  ", ChartName, " Price at/above UpperLR "+ DoubleToStr(UpperLR ,digits)); }
     if( Close[0] <= LowerLR ) { Trigger = Time[0] ; Alert(symbol,"  ", ChartName, " Price at/below LowerLR "+ DoubleToStr(LowerLR ,digits)); }     
   
   }

   if(PriceBoxShow) DoBoxes();
    
   OldBars = Bars ;   

   WindowRedraw() ;

}


//____________________________________________________________________________________________________________________________________________________________
//DRAW CHANNEL FOR GIVEN PERIOD

void DrawChannel(int cperiod, int slope){

	if (cperiod!=period) switch(cperiod) {
		
			case PERIOD_W1: { if(slope > 0) ChannelColor=WeekColorUp; 	else if(slope < 0) ChannelColor=WeekColorDn;	else  ChannelColor=WeekColorEq; 	break; }
			case PERIOD_D1: { if(slope > 0) ChannelColor=DayColorUp; 	else if(slope < 0) ChannelColor=DayColorDn;  else  ChannelColor=DayColorEq; 	break; }
			case PERIOD_H4: { if(slope > 0) ChannelColor=H4ColorUp;		else if(slope < 0) ChannelColor=H4ColorDn;  	else  ChannelColor=H4ColorEq; 	break; }
			case PERIOD_H1: { if(slope > 0) ChannelColor=H1ColorUp; 		else if(slope < 0) ChannelColor=H1ColorDn;  	else  ChannelColor=H1ColorEq; 	break; }
			default: { if(slope > 0) ChannelColor = ChannelColorUp;		else if(slope < 0) ChannelColor = ChannelColorDn;  else  ChannelColor = ChannelColorEq; }
			
	} else { if(slope > 0) ChannelColor = ChannelColorUp ; else if(slope < 0) ChannelColor = ChannelColorDn;  else  ChannelColor = ChannelColorEq; }
	
   string name=Time_TFToString(cperiod);
   
   Draw_TLine(tag, ChartName+"_"+name+"_TL1",  ChannelLineStyle, ChannelLineWidth, ChannelColor, T2, PP + Step*AB, T1, PP, ChannelRay	, true, 0);
   ObjectSetText(tag+ChartName+"_"+name+"_TL1",name+ " SHI");
   Draw_TLine(tag, ChartName+"_"+name+"_TL2",  ChannelLineStyle, ChannelLineWidth, ChannelColor, T2, P2, T1, P1, ChannelRay	, true, 0);
   ObjectSetText(tag+ChartName+"_"+name+"_TL2",name+ " SHI");
   Draw_TLine(tag, ChartName+"_"+name+"_MIDL", ChannelMidLineStyle,   ChannelMidLineWidth, ChannelColor, T2, (P2 + PP + Step*AB) / 2, T1, (P1 + PP) / 2, ChannelRay	, true, 0);
   ObjectSetText(tag+ChartName+"_"+name+"_MIDL",name+ " SHI");
   
   if (FiboShow && cperiod==period) {
		
   	Draw_FiboChannel(tag, ChartName+"_FIBOCHAN", FiboStyle, FiboWidth, FiboColor, FiboLevelStyle, FiboLevelWidth, FiboLevelColor,  T2, P2, T1, P1, T2, PP + Step*AB, ChannelRay, true, 0);
   
   }

}


//____________________________________________________________________________________________________________________________________________________________
//DRAW PRICE BOXES ON CHANNEL LINES

void DoBoxes(){

	Draw_PriceBox(tag, ChartName+"Upper", false, PriceBoxWidth, PriceBoxColor, Time[0], UpperLR, true, 0);
	Draw_PriceBox(tag, ChartName+"Lower", false, PriceBoxWidth, PriceBoxColor, Time[0], LowerLR, true, 0);
	Draw_PriceBox(tag,ChartName+"Mid", 	false, PriceBoxWidth, PriceBoxColor, Time[0], MiddleLR, true, 0);
               

}

//____________________________________________________________________________________________________________________________________________________________
//DETERMINE WHAT THE SHI CHANNEL IS FOR THIS CURRENCY AND TIMEFRAME

int PeriodTrend(string pair, int tf, int tbars) {

   if((tbars == 0) || (iBars(pair,tf) < tbars))  AB = iBars(pair,tf); else AB = tbars; 
   
   if(BarsForFract > 0) BFF = BarsForFract; 
          
   	else  switch (tf){
       
        	case  PERIOD_M1: 	BFF = 12; break;
        	case  PERIOD_M5: 	BFF = 24; break; // was 48
        	case  PERIOD_M15: BFF = 24; break;
        	case  PERIOD_M30: BFF = 24; break;
        	case  PERIOD_H1: 	BFF = 12; break;
        	case  PERIOD_H4: 	BFF = 15; break;
        	case  PERIOD_D1: 	BFF = 10; break;
        	case  PERIOD_W1: 	BFF = 6;  break;
        	case  PERIOD_MN1: BFF = 6;  break;
        	default: Alert("TIMEFRAME ERROR"); 
        	return(-1); 
        	              
   }
            
   CurrentBar = 2; 
   B1 = -1; 
   B2 = -1; 
   UpDown = 0;
   while(((B1 == -1) || (B2==-1)) && (CurrentBar<AB)) {
   
          if((UpDown < 1) && (CurrentBar == iLowest(pair, tf, MODE_LOW, BFF*2 + 1, CurrentBar - BFF))) {
          
                 if(UpDown == 0) { 
                 
                     UpDown = -1; 
                     B1 = CurrentBar; 
                     P1 = iLow(pair,tf,B1);
                      
                 } else  { 
                 
                     B2 = CurrentBar; 
                     P2 = iLow(pair,tf,B2);
                     
                 }
                 
           }
           
          if((UpDown > -1) && (CurrentBar == iHighest(pair, tf, MODE_HIGH, BFF*2 + 1, CurrentBar - BFF))) {
          
                 if(UpDown == 0){ 
                 
                     UpDown = 1; 
                     B1 = CurrentBar; 
                     P1 = iHigh(pair,tf,B1);
                      
                 } else { 
                 
                     B2 = CurrentBar; 
                     P2 = iHigh(pair,tf,B2); 
                     
                 }
                 
          }
          
          CurrentBar++;
          
   }
   
   if((B1 == -1) || (B2 == -1)) {
   
       DeleteObjectsByPrefix(tag); 
       return(-1);
       
   } 
   
   Step = (P2 - P1) / (B2 - B1); 
   P1 = P1 - B1*Step; 
   B1 = 0; 
   ishift = 0; 
   iprice = 0;
   if(UpDown == 1) { 
   
          PP = iLow(pair,tf,2) - 2 * Step;
          
          for(i = 3; i <= B2; i++)  if(iLow(pair,tf,i) < PP + Step*i)  PP = iLow(pair,tf,i) - i*Step; 

          if(iLow(pair,tf,0) < PP) { ishift = 0; iprice = PP; }
          
          if(iLow(pair,tf,1) < PP + Step) { ishift = 1; iprice = PP + Step; }
          
          if(iHigh(pair,tf,0) > P1) { ishift = 0; iprice = P1;  }
          
          if(iHigh(pair,tf,1)  > P1 + Step) { ishift = 1; iprice = P1 + Step; }
          
   } else { 
   
          PP = iHigh(pair,tf,2)  - 2 * Step;
          
          for(i = 3; i <= B2; i++)  if(iHigh(pair,tf,i) > PP + Step*i) PP = iHigh(pair,tf,i) - i*Step;

          if(iLow(pair,tf,0) < P1) { ishift = 0; iprice = P1;  }
          
          if(iLow(pair,tf,1) < P1 + Step) { ishift = 1;  iprice = P1 + Step; }
          
          if(iHigh(pair,tf,0)  > PP) { ishift = 0; iprice = PP; }
          
          if(iHigh(pair,tf,1)  > PP + Step) { ishift = 1;  iprice = PP + Step; }
          
   }

   P2 = P1 + AB * Step;
   T1 = iTime(pair,tf,B1); 
   T2 = iTime(pair,tf,AB);

	ChannelSize 		= MathAbs(PP - P1) / Point ;
	double xSlope     = -Step / Point ;
	double qq1 			= NormalizeDouble(PP,digits) ;
	double qq2 			= NormalizeDouble(P1,digits) ;

   LowerLR  = MathMin(qq1,qq2) ;
   UpperLR  = MathMax(qq1,qq2) ;
   MiddleLR = NormalizeDouble((P1 + PP) / 2 ,digits) ;     
                  
              
   return(xSlope);


}